#include "MAC.H"

struct NODE_PORTA {
		int num_porta;
		int velocita;
		LISTA_MAC mac;
		NODE_PORTA * next;
};

class LISTA_PORTA {
	private:
		NODE_PORTA *head;
		NODE_PORTA *tail;
	public:
		LISTA_PORTA();
		~LISTA_PORTA();
		
		void printPORT();          //stampa tutte le PORTE
		int search(int);           //cerca Porta  
		void remove(int);          //rimuovi porta 
		void insert(NODE_PORTA*);          //aggiungi nodo in ordine

		void insertMAC(NODE_MAC*); //aggiungi MAC
		void searchMAC(char*);      //ricerca MAC
		void printMAC(int);        //stampa MAC
		void readFile();
		void saveFile();
		int  delMAC(int,char*);     //cancella MAC  
		void delOldMAC(int,int);       //cancella vecchi MAC
		
};

