#include "CLASSI\GATE.H"
#include <string.h>
#include <iostream.h>
#include <stdio.h>
#include "CLASSI\UTI.H"

LISTA_PORTA::LISTA_PORTA(){
	head = NULL;
	tail = NULL;
}

LISTA_PORTA::~LISTA_PORTA(){
}

void LISTA_PORTA::printPORT(){          //#6 (sostituire il printnum con print (passare 2 parametri)
	struct NODE_PORTA* temp = head;
	if (temp==NULL) cout <<"The GATE'S LIST is empty"<<endl;
	while(temp!= NULL){
		cout <<" n.Gate: " << temp->num_porta<<endl;
		cout <<" Speed: "<<temp->velocita<<" baud"<<endl;
		temp->mac.print();
		temp=temp->next;
		cout<<endl;
	}
}
int LISTA_PORTA::search(int numero){           
	struct NODE_PORTA* temp = head;
	while((temp!=NULL)&&(temp->num_porta!=numero)){
	   temp=temp->next;
	}
	if (temp==NULL)return(NULL);
	   else return(numero);
}

void LISTA_PORTA::remove(int numero){         //#5
	struct NODE_PORTA* puntatore = head;
	struct NODE_PORTA* temp = NULL;
	
	int risp=51;
	char rispo;
	while(puntatore->num_porta!=numero){
		temp=puntatore;
		puntatore=puntatore->next;
	}
	while ((risp==51)) {
		cout <<" n.Gate: "<<puntatore->num_porta<<endl;
		cout <<" Speed: "<< puntatore->velocita <<" baud"<<endl;
		cout <<"Do you want  to delete this?? "<<endl;
		cout <<"[hit 1 for delete or 2 to be continued]"<<endl;
		cin>>rispo;
		risp=rispo;
		if ((risp!=49)&&(risp!=50)) risp=51;
	}
	if ((risp==49)&&(head==tail)){
		puntatore->mac.delport(numero);
		head=NULL;
		tail=NULL;
	}
	else if ((risp==49)&&(puntatore==head)){
			head=puntatore->next;
		}
		else if (risp==49){
				temp->next=puntatore->next;
			}
	
	puntatore=head;
	while(puntatore !=NULL){
		puntatore=puntatore->next;
	}
	tail=puntatore;
}

void LISTA_PORTA::insert(NODE_PORTA* goofy){       //num #1
	UTI utility;
	struct NODE_PORTA* new_elem  = new NODE_PORTA;
	
	new_elem->num_porta=goofy->num_porta;
	new_elem->velocita=goofy->velocita;
	new_elem->next=NULL;
	
	// codice per inserimento dati ordinato x porta dal minore al maggiore
    
	struct NODE_PORTA* temp2 = head;
	struct NODE_PORTA* temp = head;

	if (head==NULL){
			head=tail=new_elem;
			return;
	}
	
	if (new_elem->num_porta<temp2->num_porta) {
		new_elem->next=head;
		head=new_elem;
		return;
	}
	
	while (new_elem->num_porta>temp2->num_porta){
		temp=temp2;
		temp2=temp2->next;
		if (temp2==NULL) break;
	}
	
	new_elem->next=temp2;
	temp->next=new_elem;
	if (new_elem->next==NULL) 
		tail=new_elem;
	//fine funzione di inserimento ordinato
	 
}






void LISTA_PORTA::insertMAC(NODE_MAC* XXX){          //#2
	struct NODE_PORTA* temp = head;
	while(temp->num_porta!=XXX->num_porta){
	   temp=temp->next;
	}
	temp->mac.insert(XXX);
} 

void LISTA_PORTA::searchMAC(char* indirizzo){           //#3 
	struct NODE_PORTA* temp = head;
	while(temp!=NULL){
		if (temp->mac.search(indirizzo)){
			cout<<"Gate: "<<temp->num_porta<<endl;
			temp->mac.print(indirizzo);	   
		}
		temp=temp->next;
		
	}
}	


void LISTA_PORTA::printMAC(int numero){            //#10
	struct NODE_PORTA* temp = head;
	while(temp->num_porta!=numero){
	   temp=temp->next;
	}
	temp->mac.print();
}


int LISTA_PORTA::delMAC(int numero,char* indirizzo){     //#4
	struct NODE_PORTA* temp = head;
	while(temp->num_porta!=numero){
	   temp=temp->next;
	}
	if (temp->mac.search(indirizzo)) {
		temp->mac.remove(indirizzo,numero);
		return(true);
	}
return(false);
}

void LISTA_PORTA::delOldMAC(int numero,int giorni){         //#11
	struct NODE_PORTA* temp = head;
	while(temp->num_porta!=numero){
	   temp=temp->next;
	}
	temp->mac.removeOLD(giorni);
}

void LISTA_PORTA::readFile(){
	FILE *in;
	char xxx[16];
	in=fopen("dati.gat","r+");
	struct NODE_PORTA* temp = new NODE_PORTA;
	while(!feof(in)){
		fscanf(in," %s %d %s %d \n",xxx,&temp->num_porta,xxx,&temp->velocita);
		if(search(temp->num_porta)==NULL) insert(temp);
		else {
			cout<<"Error Gate "<<temp->num_porta<<" already exist"<<endl;
			cout<<"the gate is not reload"<<endl;
		}
	}
	fclose(in);
}

void LISTA_PORTA::saveFile(){
	FILE *out;
	struct NODE_PORTA* temp = head;
	out=fopen("dati.gat","w");
	while(temp!=NULL){
		fprintf(out," %s %d %s %d \n","Gate:",temp->num_porta,"Speed:",temp->velocita);
		temp=temp->next;
	}
	fclose(out);
}
		
