#include "CLASSI\UTI.H"
#include "CLASSI\GATE.H"
#include <string.h>
#include <stdio.h>
#include <iostream.h>

void print_Menu(void);
void main(){
	LISTA_PORTA lista;	//inizializzazione della lista linkata
	LISTA_MAC maclst;	//inizializzazione della lista mac 
	struct NODE_PORTA* gate  = new NODE_PORTA;
	struct NODE_MAC* punt  = new NODE_MAC;
	UTI utility;        //utility 
	int temp;
	char tempi[20];
	for(;;){  
		char prog='z';
		print_Menu();
		cin>>prog;
		cout<<endl;
		if (prog>94) prog -=32;
		switch (prog)
			{
			case 'A':	cout<<"Please Insert the gate's number: ";
						temp=utility.numero();
						gate->num_porta=temp;
						
						if (lista.search(temp)==NULL){ 
							
							cout<<"Insert gate's speed (baud): ";
							gate->velocita=utility.numero();
							
							lista.insert(gate);
						}
						else cout<<endl<<"Error... gate's number is already inserted"<<endl;
						
						break;
	      				
			case 'B':	cout<<"Please Insert the gate's number: ";
						temp=utility.numero();
						if (lista.search(temp)!=NULL) { 
							strcpy (punt->indirizzo,utility.controllo());
							punt->next=NULL;
							punt->num_porta=temp;
							punt->data=utility.date();
							lista.insertMAC(punt);
							maclst.insert(punt);
						} 
						else cout<<endl<<"Error... gate's number is not found"<<endl;
						break;
	      	case 'C':   cout<<"Please Insert the gate's number: ";
						temp=utility.numero();
						if (lista.search(temp)!=NULL){				
							cout<<"Insert address: ";	
							strcpy (tempi,utility.controllo());
							lista.searchMAC(tempi);
						}else cout<<"Error... gate's number is not found"<<endl;
						break;
			case 'D':	cout<<"Please Insert the gate's number: ";
						temp=utility.numero();
						if (lista.search(temp)!=NULL){				
							cout<<"Insert address: ";	
							strcpy (tempi,utility.controllo());
							if(lista.delMAC(temp,tempi)) maclst.remove(tempi,temp);
						}
						break;
			case 'E':	cout<<"Please Insert the gate's number to destroy: ";
						temp=utility.numero();
						if (lista.search(temp)!=NULL) {
							lista.remove(temp);
							maclst.delport(temp);
						}
						else cout<<endl<<"gate's number is not found"<<endl;
						break;
	      	case 'F':	lista.printPORT();
						break;
			case 'G':	cout<<"Please Insert the gate's number: ";
						temp=utility.numero();
						lista.printMAC(temp);
						break;
			case 'H':	maclst.print2();
						break;
	     	case 'I':	maclst.saveFile();
						lista.saveFile();
						cout<<endl<<"Uploading complete"<<endl;
						break;
	        case 'L':	lista.readFile();
						FILE *in;
						char xxx[20];
						char indirizzo[20];
						unsigned long data;
						in=fopen("dati.mac","r");//r = apre un file di testo x operazioni di lett
						while(!feof(in)){//cicla finche arriva a fine del file.
							fscanf(in,"%12s%d%9s%15s%4s%d\n",xxx,&temp,xxx,indirizzo,xxx,&data);
							punt->next=NULL;
							punt->data=data;
							strcpy(punt->indirizzo,indirizzo);
							punt->num_porta=temp;
							 {
								if (maclst.search(punt->indirizzo)==punt->data)break;
								if (maclst.search(punt->indirizzo)!=NULL)
								  if (maclst.search(punt->indirizzo)<punt->data){
									lista.delMAC(punt->num_porta,punt->indirizzo);
									maclst.remove(punt->indirizzo,punt->num_porta);
								}
								lista.insertMAC(punt);
								maclst.insert(punt);
							}
						}
						fclose(in);
						cout<<endl<<"Downloading complete"<<endl;
						break;
//	        case 'W':	cout<<"Da implementare"<<endl;	
//						break;
	        
			case 'X':   return;
		  	default :	cout<<endl; 
					cout<<"You have make a mistake...Try again..."<<endl;
					cout<<"There's nothing to be afraid "<<endl;
			}	
	}
}

void print_Menu(void){
	cout<<endl;
	cout<<"A) Insert Gate"<<endl;
	cout<<"B) Insert MAC address"<<endl;
	cout<<"C) Search MAC address"<<endl;
	cout<<"D) Delete MAC address to a gate"<<endl;
	cout<<"E) Delete Gate"<<endl;
	cout<<"F) Print of Gates"<<endl;
	cout<<"G) Print of MAC addresses by gate"<<endl;
	cout<<"H) Print of MAC addresses"<<endl;
	cout<<"I) Save the configuration in a file"<<endl;
	cout<<"L) Load configuration from a file"<<endl;
//	cout<<"W) Delete the older MAC address(optional)"<<endl;
	cout<<endl;
	cout<<"X) For exit program"<<endl;
	cout<<endl;
	cout<<"Choose the function to execute: ";
}
