#include "CLASSI\MAC.H"
#include <string.h>
#include <stdio.h>
#include <iostream.h>
#include "CLASSI\UTI.H"

LISTA_MAC::LISTA_MAC(){
	headMAC = NULL;
	tailMAC = NULL;
}

LISTA_MAC::~LISTA_MAC(){
}
long LISTA_MAC::search(char* temp){
	struct NODE_MAC* puntatore = headMAC;
	while(puntatore!=NULL){
		if (strcmp (puntatore->indirizzo,temp)==0) return(puntatore->data);
		puntatore=puntatore->next;
	}
return(false);
}
void LISTA_MAC::delport(int porta){
	struct NODE_MAC* temp = headMAC;
	while (temp!=NULL){
	if (temp->num_porta==porta) remove(temp->indirizzo,porta);	
	temp=temp->next;
	}		
	
}

void LISTA_MAC::removeOLD(int giorni){
	struct NODE_MAC* temp = headMAC;
	struct NODE_MAC* temp2 = NULL;
	
	UTI a;

	//while((temp->data)>(a.giorni(giorni))){
		temp2=temp;
		temp=temp->next;
	//}
	tailMAC=temp2;
	tailMAC->next=NULL;
}

void LISTA_MAC::remove(char* indirizzo,int num_porta){

	struct NODE_MAC* puntatore = headMAC;
	struct NODE_MAC* temp = NULL;
	struct NODE_MAC* temp2 = NULL;
	
	while ((strcmp(puntatore->indirizzo,indirizzo)!=0)&&(puntatore->num_porta!=num_porta))   {
		temp=puntatore;
		puntatore=puntatore->next;
	}		
	if (headMAC==tailMAC){
		tailMAC=NULL;
		headMAC=NULL;
	} else
	if ((headMAC==puntatore)&&(tailMAC!=puntatore))
		headMAC=puntatore->next;
	else
	if ((tailMAC==puntatore)&&(headMAC!=puntatore)){
		tailMAC=temp;
		temp->next=NULL;
	} else temp->next=puntatore->next;
}


void LISTA_MAC::insert(NODE_MAC* temp2){
	struct NODE_MAC* puntatore = new NODE_MAC; 
	struct NODE_MAC* puntatore1 = headMAC;
	struct NODE_MAC* temp=NULL;
	
	puntatore->data=temp2->data;
	strcpy (puntatore->indirizzo,temp2->indirizzo);
	puntatore->num_porta=temp2->num_porta;
	puntatore->next=NULL;
	
		
	if (headMAC==NULL){
			headMAC=puntatore;
			tailMAC=puntatore;
			return;
	}
	
	while ((puntatore1!=NULL)&&(puntatore1->data<puntatore->data)){
		temp=puntatore1;
		puntatore1=puntatore1->next;
	}
	if (puntatore1==headMAC) 
		headMAC=puntatore;
	else 
		temp->next=puntatore;
	
	puntatore->next=puntatore1;

	temp=headMAC;
	while(temp!=NULL){
		temp=temp->next;
	}
	tailMAC=temp;
}
void LISTA_MAC::print2(){
	struct NODE_MAC* temp = headMAC;
	UTI a;
	char data[16]="";
	char ind[20]="";
	while(temp!=NULL){
		strcpy(ind,temp->indirizzo);
		cout<<" Address: ";
		for(int i=0;i<15;i++)cout<<ind[i];
		cout<<endl<<" n.Gate: "<<temp->num_porta<<endl;
		strcpy(data,a.etad(&temp->data));
		cout<<" Date: "<<data<<endl;
		temp=temp->next;
	}
		
}
void LISTA_MAC::print(){
	struct NODE_MAC* temp = headMAC;
	UTI a;
	char data[16]="";
	char ind[20]="";
	while(temp!=NULL){
		strcpy(ind,temp->indirizzo);
		cout<<" Address: ";
		for(int i=0;i<15;i++)cout<<ind[i];
		strcpy(data,a.etad(&temp->data));
		cout<<"\t Date: "<<data<<endl;
    	temp=temp->next;
	}
		
}

void LISTA_MAC::print(char* indirizzo){
	struct NODE_MAC* temp = headMAC;
	char ind[20]="";
	UTI a;
	while(temp!=NULL){
		if (strcmp(temp->indirizzo,indirizzo)==0){
			strcpy(ind,temp->indirizzo);
			cout<<" Address: ";
			for(int i=0;i<15;i++)cout<<ind[i];
			cout<<"Date: "<<*a.etad(&temp->data);
		}
		temp=temp->next;
	}
		
}

void LISTA_MAC::printNUM(){  
	struct NODE_MAC* temp = headMAC;
	int i=0;
	while(temp!=NULL){
		i++;
		temp=temp->next;
	}
	cout<<" There";
	if (i>1) cout<<" are ";
		else cout<<" is ";
	cout<<i<<" MAC addresses on this gate"<<endl;
}


void LISTA_MAC::saveFile(){
	FILE *out;
	struct NODE_MAC* temp = headMAC;
	out=fopen("dati.mac","w");
	while(temp!=NULL){
		fprintf(out,"%12s%d%9s%15s%4s%d\n","Numero_porta",temp->num_porta,"Indirizzo",temp->indirizzo,"Data",temp->data);
		temp=temp->next;
	}
	fclose(out);
}
		