#include "CLASSI\UTI.H"
#include <string.h>
#include <iostream.h>
#include <time.h>
#define sday	86400
#define int_char	48

UTI::UTI()
{
}

UTI::~UTI()
{
}

long giorni(int day){
	long actual=time(NULL);
	actual-=(sday*day);
  return(actual);
}


char* UTI::controllo(){
	char temp[20];
	char tmp[3];
	int x;                           
	while(x!=4){	
		x=0;	
		cout<<"Please insert address (es. 001.002.003.004): ";	
		cin>>temp;
		for(int i=0;i<4;i++){	
			tmp[0]=temp[0+(i*4)];
			tmp[1]=temp[1+(i*4)];
			tmp[2]=temp[2+(i*4)];
			if ((strcmp(tmp,"000")>=0)&&(strcmp(tmp,"256")<0)) x++;
		}
	}	
	return(temp);
}



//  restituisce il numero immesso purificandolo da eventuali impurit
int UTI::numero()
{
	int a,x,i=0;
	char temp[80];
	while(i==0){
		a=0;
		x=0;
		cin>>temp; 
		while(temp[x]!=NULL){
				a=temp[x];
				if ((a>='0') && (a<='9')) i=i*10+(a-48);
				x++;
		}
		if (i==0)cout<<"Error...Repeat please"<<endl;
	}
	return(i);
}

char* UTI::etad(long * data){
	char tmp[16]="";
	struct tm* temp = gmtime(data);
	if ((temp->tm_mday)<10){ 
		tmp[0]='0';
		tmp[1]=(temp->tm_mday)+int_char;
	}
	else {
		tmp[0]=((temp->tm_mday)/10)+int_char;
		tmp[1]=((temp->tm_mday)%10)+int_char;
	}
    tmp[2]='/';
	if ((temp->tm_mon+1)<10){ 
		tmp[3]='0';
		tmp[4]=((temp->tm_mon+1)+int_char);
	}
	else {
		tmp[3]=((temp->tm_mon+1)/10)+int_char;
		tmp[4]=((temp->tm_mon+1)%10)+int_char;
	}
    tmp[5]='/';
	int tempi=temp->tm_year+1900; 
	tmp[6]=(tempi/1000)+int_char;
	tmp[7]=(tempi/100)-((tempi/1000)*10)+int_char;
	
	tmp[8]=(  (tempi/10)-(tempi/100)*10  )+int_char;
	tmp[9]=(tempi%10)+int_char;
	
	return(tmp);	
}

long UTI::date(void){
tm ins_date;
	int temp=0;
	int anno;
	ins_date.tm_hour=12;
	ins_date.tm_min=0;
	ins_date.tm_sec=0;
	
	while (temp==0){
		cout<<"Insert year(must be greater than 1900): ";
		cin>>temp;
		if (temp>1900) ins_date.tm_year=temp-1900;
			else temp=0;
	}
	anno=ins_date.tm_year+1900;
	temp=0;
	while (temp==0){
		cout<<"Insert month (must be included from 1 to 12): ";
		cin>>temp;
		if ((temp>0)&&(temp<13)) ins_date.tm_mon=temp-1;
			else temp=0;
	}
	temp=0;
	while (temp==0){
		cout<<"Insert day (must be included from 1 to 31): ";
		cin>>temp;
		
		switch (ins_date.tm_mon){
			case 10:
			case 3:
			case 5:
			case 8:if (temp>30) temp=0;break;
			case 1:if (((anno%4)==0)&&(((anno%100)!=0)||((anno%400)==0)))
					  if (temp>29)temp=0;
					  else temp=temp;
					else if (temp>28)temp=0;
					break;
			default: if(temp>32)temp=0;
		}
		if (temp>0) ins_date.tm_mday=temp;
			else temp=0;
	}
long x=mktime(&ins_date);
return(x);
}
